#pragma once

//! Window Blob
struct windowB
{
	std::vector <cv::Point> windowBorder;
};

//! Window corners & centre
struct windowCC
{
	cv::Point centre;
	cv::Point lUp;
	cv::Point rUp;
	cv::Point rDown;  //0  1
	cv::Point lDown;  //3  2
};

//! Provides data about detected colors in frame
struct frameColorInfo
{
	bool anyColors = false;
	bool red = false;
	bool green = false;
	bool blue = false;
	cv::Scalar colorMat = cv::Scalar(-1, -1, -1);
};

//! Carries points (to create windows) and gray frame
struct frameCnts
{
	std::vector <std::vector <cv::Point> > windowBorder;
	cv::Mat grayFrame;
};

//! To use mouse
struct mouseAction
{
	bool startPress = false, endPress = false;
	cv::Point startPoint, endPoint, currentPoint;
};

//! Carries window coordinate on building (X,Y) along with accuracy (currently unused)
struct finalWin
{
	cv::Point coordinate;
	float accuracy;
};

//! Carries window possition on camera along with its coordinates on buildin
struct windowsCoordinates
{
	windowCC window;
	cv::Point point;
};

//! Data aboul window coordinates and its color
struct coorColor
{
	cv::Point coor;
	cv::Scalar color;
};

struct colorLibrary
{
	cv::Point coordinate;
	float accuracy = 0;
	cv::Mat red;
	cv::Mat green;
	cv::Mat blue;
};

enum whatIsHappeningInLSD { NO_ERRORS, TIME_EXCEEDED, NO_WINDOWS_FOUND, NO_INPUT_DETECTED, WINDOW_SIZE_IS_ZERO, WRONG_GIVEN_COORDINATE_X, WRONG_GIVEN_COORDINATE_Y,
 NO_TRANSFORM_MATRIX_GENERATED, EMPTY_WINDOW_ARRAY, INCORRECT_WINDOW_ARRAY, WRONG_DIMENSION_WIDTH, WRONG_DIMENSION_HEIGHT, EMPTY_INPUT_GIVEN, NOT_ENOUGH_INPUT_DATA,
 EMPTY_MAT_ARRAY, INCORRECT_MAT_ARRAY, WRONG_COLORSPACE_SIZE, BGR_TABLE_EMPTY, NOT_ENOUGH_WINDOWS_TO_CHOOSE_CORNERS, TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT,
 INCORRECT_ARRAY, WRONG_WINDOW_AMOUNT, WRONG_COLOR_THRESHOLD_LVL, WRONG_CASCADE_NAME, CASCADE_NOT_LOADED, WRONG_TIME_GIVEN, SIZES_DOES_NOT_MATCH, INPUTS_SIZES_NOT_MATCH};

//Really need to make not-global
//Right now unnable to do so
mouseAction mouse;

//PIWO7 format
//0000 0000 0000 0000 0000 0000
//--------- --------- ---------
//R         G         B
//Then transfer to DEC

class lsd
{
private:
	//! Number of window columns
	int windowsX = 1;
	//! Number of window rows
	int windowsY = 1;
	//! Resolution of pop-up windows
	int preview[2] = { 640, 480 };
	//! Number of frames per color
	int calibrationAccuracy = 1;
	//! 0-R, 1-G, 2-B. Way in which colors will be detected. Two same colors cannot be near themselves ({0,0,2} is forbidden, but {0,2,0} is good) 
	int schematic[3] = { 0,1,2 };
	//! Name of the test file
	std::string testPath = "test.mp4";
	//! ID of the webcam
	int webcamPath = 0;
	//! Says if tests are in progres
	bool testBool = false;
	//! Thresholding lvl min
	int threshLvlLow = 180;
	//! Thresholding lvl high
	int threshLvlHigh = 255;
	//! dConst
	float dConst = 25;
	//! For four-point-transform
	windowCC transformMatrix;
	//! For four-point-transform 
	cv::Point2f inptQ[4];
	//! For four-point-transform
	cv::Point2f outpQ[4];
	//! Transformation matrix
	cv::Mat transformMat;
	//! States if trans. Matrix is created 
	bool isTransform;
	//! LSD status
	whatIsHappeningInLSD status = NO_ERRORS;
	//! Rate at which windows generated by LSD are refreshed. Value is frames per second
	int maxFRAMERATE = 16;
	//! Lower color thresholding lvl
	std::vector <cv::Scalar> colLow;
	//! Higher color thresholding lvl
	std::vector <cv::Scalar> colHigh;

	//! 2D array of windows
	std::vector <std::vector <windowCC> > twoDim;

	//RXList - ???

	//Functions
	//! If testing, slows video from file; If live makes frame delay minimal
	int frameTime(int time0)
	{
		if (testBool) return time0;
		return int(1000 / maxFRAMERATE);
	}
	//! Finds too small and too big windows and removes them
	std::vector <windowCC> deleteArtiffacts(std::vector <windowCC>& windowList);
	//! Creates 2D array of windows
	void arrayTo2DArray(std::vector <windowCC>& windowList);

	//calibration is finction, where whole magic happenes
	//It receives 2D Mat vector, which contains mats with detected colors, array looks like this
	//<R G B>
	// R G B
	// R G B
	//Next parameter is Scalar vector, it contains color thresholds. It allows to extract only lit windows
	//Then lit windows are put on binary mat, which is later logically added (binary_and) to map matching blobs
	//At the end, windows are translated from Blobs to windowCC vector
	std::vector <windowCC> calibration(std::vector <std::vector <cv::Mat> >& windowMats, std::vector <cv::Scalar>& color_Low, std::vector <cv::Scalar>& color_High, int width, int height);

	//! Bool to help sort windows
	static bool sortByX(windowCC a, windowCC b);
	//! Bool to help sort windows
	static bool sortByY(windowCC a, windowCC b);

	//FrameColorInfo states if color level on frame is high enough to trigger further actions
	//If baseMat is made of (-1,-1,-1), func will only return basic mat of frame colors
	//! Detects main colors from image
	frameColorInfo isColorFromFeed(cv::Mat frame, cv::Scalar baseMat, float sensR = 1, float sensG = 1, float sensB = 1);
	//! Extracts colors from mats, then applies logic operations to find window blobs
	frameCnts cummulation(std::vector <std::vector <cv::Mat> >& matList, std::vector <cv::Scalar>& color_Low, std::vector <cv::Scalar>& color_High);
	//! Extracts colors from frame; returns bool frame and blobs
	frameCnts extract(cv::Mat, cv::Scalar colour_Low, cv::Scalar colour_High);
	//! Allows user to manually delete windows
	void deleteWindows(std::vector <windowCC>& windowList, cv::Mat frame);
	//! Allows user to manually add windows
	void addWindows(std::vector <windowCC>& windowList, cv::Mat frame);
	//! Allows user to manually choose corner windows
	void chooseCorners(std::vector <windowCC>& windowList, cv::Mat frame);
	//! Creates transformation mat from gathered data
	void getWindowsPerspective(int width, int height, std::vector <windowCC>& windowList);
	//! Simplifies windows blobs to windowCC
	void getWindowsCorners(int width, int height, std::vector< std::vector <cv::Point> >& wa, std::vector <windowCC>& wm);
	//! Tries to find corners of blob
	void cornerSearch(int width, int height, std::vector <cv::Point>& pts, windowCC& wcc);
	//! Defines centre of windowCC
	void centreSearch(windowCC& wcc);
	//! Creates centre (average of all points)
	cv::Point centreSearch(windowB& wb);
	//! Creates window graphics on frame
	void windowPainter(cv::Mat& frame, windowCC& window, cv::Scalar color);
	//! 2D cv::Point translation to 1D windowB
	void vvp2vwb(std::vector <std::vector <cv::Point> >& points, std::vector <windowB>& winB);
	//! 1D windowB translation to 2D cv::Point
	void vwb2vvp(std::vector <windowB>& winB, std::vector <std::vector <cv::Point> >& points);
	//! Creates 2D matrix of single windows
	void matMatrixAssigner(std::vector <std::vector<cv::Mat> >& mats, cv::Mat frame, bool isFirst = false);
	//! Translates rectangle vector to windowCC vector
	void rect2windowsCC(std::vector <cv::Rect>& r, std::vector <windowCC>& w);
	//! Due to difference in source resolution and preview resolution, mouse clicks are to be translated/recalculated
	cv::Point calculateResizedPossition(cv::Point pt, cv::Mat& source);
	//! Defines dimensions of window(width, height, upper left corner coordinates)
	cv::Rect windowMask(windowCC& window);
	//Trying to get mouse working
	//void ButtonTest();
	//! Calculates time and determines if action is taking too long
	bool hasTimeExceeded(clock_t& start, clock_t& end, float timeLimit);
	//! Mouse capture
	friend void onMouse(int event, int x, int y, int flag, void* userdata);
	//! Calculates distance between pixels; calculates accuracy from choosen windows
	float windowColorAccuracy(colorLibrary differentColors, std::vector <cv::Scalar>& thLow, std::vector<cv::Scalar>& thHigh);
	//! Used to create frames with colors and levels, for setColorRanges
	void createColorSliders(cv::Mat & frame, cv::Scalar & colL, cv::Scalar & colH);
	//! Used to determine mouse effect on frame
	void setColorRangesMouse(cv::Scalar & low, cv::Scalar & high, int & active, cv::Mat & out);

public:
	//! Main class
	lsd();

	//! Allows user to change max framerate (FPS)
	void changeMaxFRAMERATE(int newFramerate)
	{
		maxFRAMERATE = newFramerate;
	}

	//! Plays video from given source (dedicated for video from file)
	void playTest(cv::VideoCapture& cap);

	//! Prints info about choosen video source
	void webCamInfo(cv::VideoCapture& cap);

	//! BGR to HSV conversion
	void BGRtoHSV(int* BGRbase, float* HSV);

	//! BGR to PIWO color conversion
	uint32_t BGR2PIWODEC(cv::Scalar color);

	//! PIWO to BGR conwersion
	cv::Scalar PIWODEC2BGR(uint32_t color);

	//! Plays video from given source (dedicated for webcam)
	void camPrevShow(cv::VideoCapture& cap, bool appliedTransform = false);

	//! Returns average pixel value from MAT
	float matAverageValue(cv::Mat& frame);

	//! Returns distance between tow points
	float pointsDistance(cv::Point& a, cv::Point& b);

	//! Returns average window color in [B,G,R,alpha] (ALPHA remains unused)
	cv::Scalar windowAverageColor(cv::VideoCapture& cap, int x, int y);

	//! Displays all image sources, returns number of detected video sources (netcams)
	int getAllVideoInputs();

	//! Allows user to set color ranges (for image processing) manually
	void setColorRanges(cv::VideoCapture& cap);

	//! Enables Test mode (useful for debugging)
	void testEnable()
	{
		testBool = true;
	}
	//! Disables Test mode (useful for debugging
	void testDisable()
	{
		testBool = false;
	}

	//! Sets window number in building width
	void setWindowsX(int x)
	{
		windowsX = x;
	}
	//! Sets window number in building height
	void setWindowsY(int y)
	{
		windowsY = y;
	}

	//! Returns what is currently happening
	whatIsHappeningInLSD getLSDstatus()
	{
		return status;
	}


	//First step have to find corner windows in order to apply perspective transform
	//For standard color-search
	//! Detects windows andd creates transform.
	void firstStep(cv::VideoCapture& cap, float time = 3);
	//For cascade search
	//! Detects windows using cascades andd creates transform.
	void firstStep(cv::VideoCapture& cap, std::string cascadeName);

	//! Second step have to fond precise windows coordinates.
	void secondStep(cv::VideoCapture& cap, float time = 3);
	//! Second step have to fond precise windows coordinates using cascades.
	void secondStep(cv::VideoCapture& cap, std::string cascadeName);

	//Third step finds and passes window coordinates (in window mat)
	//Time is in seconds. After time passes, output is always cv::Point(-1,-1) and 0(%) accuracy; Accuracy is to be calculated
	//! Detects single window
	finalWin thirdStep(cv::VideoCapture& cap, float time = 3);

	//! Returns list of windows that have matching color (to pattern)
	std::vector <windowsCoordinates> findWindowsByColor(cv::VideoCapture& cap, cv::Scalar& min, cv::Scalar& max);
	//! Returns list of windows that have matching color (to pattern), uses different color format
	std::vector <windowsCoordinates> findWindowsByColor(cv::VideoCapture& cap, uint32_t min, uint32_t max);

	//! Returns list of windows along with coordinates and colors
	std::vector <coorColor> whatAreWindowColors(cv::VideoCapture& cap, float thresh = 128);

	//! Returns color of the window
	cv::Scalar whatIsMyColor(int x, int y, cv::VideoCapture& cap, float thresh = 128);
};

lsd::lsd()
{
	transformMatrix.centre.x = -1;
	transformMatrix.centre.y = -1;
	for (int i = 0; i < 4; i++)
	{
		inptQ[i] = cv::Point(-1, -1);
		outpQ[i] = cv::Point(-1, -1);
	}
	isTransform = false;

	colLow.push_back(cv::Scalar(0, 0, 16));
	colLow.push_back(cv::Scalar(0, 16, 0));
	colLow.push_back(cv::Scalar(16, 0, 0));

	colHigh.push_back(cv::Scalar(5, 5, 255));
	colHigh.push_back(cv::Scalar(16, 255, 16));
	colHigh.push_back(cv::Scalar(255, 16, 16));
}

void onMouse(int event, int x, int y, int flag, void* userdata) //DO NOT CHANGE LOCATION IN FILE; func must remain as first as possible
{
	//lsd* lsdptr = reinterpret_cast<lsd*>(userdata);
	//lsdptr->onMouse(event, x, y, flag, userdata);

	lsd& lsdptr = *(lsd*)userdata;

	if (event == cv::EVENT_LBUTTONDOWN)
	{
		mouse.startPoint = cv::Point(x, y);
		mouse.startPress = true;
	}
	if (event == cv::EVENT_LBUTTONUP)
	{
		mouse.endPoint = cv::Point(x, y);
		mouse.endPress = true;
	}
	if(event == cv::EVENT_MOUSEMOVE)
	{
		mouse.currentPoint = cv::Point(x,y);
	}
}

void lsd::createColorSliders(cv::Mat & frame, cv::Scalar & colL, cv::Scalar & colH)
{
	int x0 = int(frame.cols*0.8);
	int x1 = int(frame.cols*0.9);
	for(int y = 0; y < int(frame.rows/3); y++)
	{
		cv::line(frame,cv::Point2f(x0,y),cv::Point2f(frame.cols,y),
			cv::Scalar(0,0,int(255*y/(frame.rows/3))));
	}
	for(int y = int(frame.rows/3); y < int(frame.rows/3)*2; y++)
	{
		cv::line(frame,cv::Point2f(x0,y),cv::Point2f(frame.cols,y),
			cv::Scalar(0,int(255*(y-int(frame.rows/3))/(frame.rows/3)),0));
	}
	for(int y = int(frame.rows/3)*2; y < frame.rows; y++)
	{
		cv::line(frame,cv::Point2f(x0,y),cv::Point2f(frame.cols,y),
			cv::Scalar(int(255*(y-int(frame.rows/3)*2)/(frame.rows/3)),0,0));
	}

	int redL = (frame.rows/3) * (colL[2]/255);
	int redH = (frame.rows/3) * (colH[2]/255);

	cv::line(frame, cv::Point2f(x0, redL), cv::Point2f(x1, redL), cv::Scalar(255,255,0));
	cv::line(frame, cv::Point2f(x1, redH), cv::Point2f(frame.cols, redH), cv::Scalar(255,255,0));
	cv::line(frame, cv::Point2f(x1, redL), cv::Point2f(x1, redH), cv::Scalar(255,255,0));

	int grnL = (frame.rows/3) * (colL[1]/255) + (frame.rows/3);
	int grnH = (frame.rows/3) * (colH[1]/255) + (frame.rows/3);

	cv::line(frame, cv::Point2f(x0, grnL), cv::Point2f(x1, grnL), cv::Scalar(255,0,255));
	cv::line(frame, cv::Point2f(x1, grnH), cv::Point2f(frame.cols, grnH), cv::Scalar(255,0,255));
	cv::line(frame, cv::Point2f(x1, grnL), cv::Point2f(x1, grnH), cv::Scalar(255,0,255));

	int bluL = (frame.rows/3) * (colL[0]/255) + (2*frame.rows/3);
	int bluH = (frame.rows/3) * (colH[0]/255) + (2*frame.rows/3);

	cv::line(frame, cv::Point2f(x0, bluL), cv::Point2f(x1, bluL), cv::Scalar(0,255,255));
	cv::line(frame, cv::Point2f(x1, bluH), cv::Point2f(frame.cols, bluH), cv::Scalar(0,255,255));
	cv::line(frame, cv::Point2f(x1, bluL), cv::Point2f(x1, bluH), cv::Scalar(0,255,255));
}

void lsd::setColorRangesMouse(cv::Scalar & low, cv::Scalar & high, int & active, cv::Mat & out)
{
	//setColorRangesMouse(cv::Scalar & low, cv::Scalar & high)
	if(mouse.startPress)
	{
		//Define press zone
		if(active == -1)
		{
			if(mouse.startPoint.x > out.cols*0.8 && mouse.startPoint.x < out.cols*0.9)
				active = int(mouse.startPoint.y / ((out.rows+2)/3));

			if(mouse.startPoint.x > out.cols*0.9 && mouse.startPoint.x < out.cols)
				active = int(mouse.startPoint.y / ((out.rows+2)/3))+3;
		}

		if(mouse.endPress)
		{
			active = -1;
			mouse.startPress = false;
			mouse.endPress = false;
		}

		if(active == 0)
		{
			if(mouse.currentPoint.y < 5)
				low[2] = 0;
			else if (mouse.currentPoint.y > (out.rows/3) - 5)
				low[2] = 255;
			else
				low[2] = int(((float(mouse.currentPoint.y) / float(out.rows/3))*255));
		}
		else if(active == 1)
		{
			if(mouse.currentPoint.y - (out.rows/3) < 5)
				low[1] = 0;
			else if (mouse.currentPoint.y > (2*out.rows/3) - 5)
				low[1] = 255;
			else
				low[1] = int((float((mouse.currentPoint.y)-float(out.rows/3)) / float(out.rows/3))*255);
		}
		else if(active == 2)
		{
			if(mouse.currentPoint.y - (2*out.rows/3) < 5)
				low[0] = 0;
			else if (mouse.currentPoint.y > out.rows - 5)
				low[0] = 255;
			else
				low[0] = int((float((mouse.currentPoint.y)-float(2*out.rows/3)) / float(out.rows/3))*255);
		}
		else if(active == 3)
		{
			if(mouse.currentPoint.y < 5)
				high[2] = 0;
			else if (mouse.currentPoint.y > (out.rows/3) - 5)
				high[2] = 255;
			else
				high[2] = int((float(mouse.currentPoint.y) / float(out.rows/3))*255);
		}
		else if(active == 4)
		{
			if(mouse.currentPoint.y - (out.rows/3) < 5)
				high[1] = 0;
			else if (mouse.currentPoint.y > (2*out.rows/3) - 5)
				high[1] = 255;
			else
				high[1] = int(((float(mouse.currentPoint.y)-float(out.rows/3)) / float(out.rows/3))*255);
		}
		else if(active == 5)
		{
			if(mouse.currentPoint.y - (2*out.rows/3) < 5)
				high[0] = 0;
			else if (mouse.currentPoint.y > out.rows - 5)
				high[0] = 255;
			else
				high[0] = int((float((mouse.currentPoint.y)-float(2*out.rows/3)) / float(out.rows/3))*255);
		}
	}
}

void lsd::setColorRanges(cv::VideoCapture& cap)
{
	assert(cap.isOpened());
	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	bool isLive = !lsd::testBool;
	cv::Mat frame;
	cap >> frame;
	cv::Mat out = cv::Mat::zeros( frame.rows, int(frame.cols*1.25), frame.type() );

	cv::Scalar redLOW = colLow[0];
	cv::Scalar grnLOW = colLow[1];
	cv::Scalar bluLOW = colLow[2];

	cv::Scalar redHIG = colHigh[0];
	cv::Scalar grnHIG = colHigh[1];
	cv::Scalar bluHIG = colHigh[2];

	std::vector <cv::Mat> colBcg;
	//cv::Mat example(cv::Size(int(preview[0]/10),int(preview[1]/3)),cv::CV_8UC1);
	//colLvl.push_back(example.clone());

	std::vector <cv::Mat> sliders;

	cv::imshow("Calibration", out);
	cv::waitKey(1);
	cv::setMouseCallback("Calibration", onMouse, 0);
	mouse.endPress = false;
	mouse.startPress = false;
	int active = -1;

	for(;;)
	{
		if(!cap.isOpened())
			break;
		
		if(isLive)
			cap >> frame;

		cv::Point2f srcTri[3];
		srcTri[0] = cv::Point2f( 0, 0 );
		srcTri[1] = cv::Point2f( frame.cols, 0 );
		srcTri[2] = cv::Point2f( 0, frame.rows );
		
		cv::Point2f dstTri[3];
		dstTri[0] = cv::Point2f( int(-out.cols * 0.1), 0 );
		dstTri[1] = cv::Point2f( int(out.cols-out.cols * 0.1), 0 );
		dstTri[2] = cv::Point2f( int(-out.cols * 0.1), out.rows );

		cv::Mat warp_mat = getAffineTransform( srcTri, dstTri );
		warpAffine( frame, out, warp_mat, out.size() );
		
		createColorSliders(out, redLOW, redHIG);

		cv::Mat ext = lsd::extract(frame, redLOW, redHIG).grayFrame;
		cv::resize(ext, ext, cv::Size(preview[0], preview[1]));
		cv::resize(out, out, cv::Size(preview[0], preview[1]));

		cv::imshow("Calibration", out);
		cv::imshow("RED Extracted",ext);

		//Mouse handling
		setColorRangesMouse(redLOW,redHIG,active,out);

		char c = (char)cv::waitKey(lsd::frameTime(30));
		if (c == 32)
			isLive ^= 1;
		if (c == 113 || c == 27)
			break;
	}
	cv::destroyWindow("RED Extracted");

	for(;;)
	{
		if(!cap.isOpened())
			break;
		
		if(isLive)
			cap >> frame;

		cv::Point2f srcTri[3];
		srcTri[0] = cv::Point2f( 0, 0 );
		srcTri[1] = cv::Point2f( frame.cols, 0 );
		srcTri[2] = cv::Point2f( 0, frame.rows );
		
		cv::Point2f dstTri[3];
		dstTri[0] = cv::Point2f( int(-out.cols * 0.1), 0 );
		dstTri[1] = cv::Point2f( int(out.cols-out.cols * 0.1), 0 );
		dstTri[2] = cv::Point2f( int(-out.cols * 0.1), out.rows );

		cv::Mat warp_mat = getAffineTransform( srcTri, dstTri );
		warpAffine( frame, out, warp_mat, out.size() );
		
		createColorSliders(out, grnLOW, grnHIG);

		cv::Mat ext = lsd::extract(frame, grnLOW, grnHIG).grayFrame;
		cv::resize(ext, ext, cv::Size(preview[0], preview[1]));
		cv::resize(out, out, cv::Size(preview[0], preview[1]));

		cv::imshow("Calibration", out);
		cv::imshow("GREEN Extracted",ext);

		//Mouse handling
		setColorRangesMouse(grnLOW,grnHIG,active,out);

		char c = (char)cv::waitKey(lsd::frameTime(30));
		if (c == 32)
			isLive ^= 1;
		if (c == 113 || c == 27)
			break;
	}
	cv::destroyWindow("GREEN Extracted");

	for(;;)
	{
		if(!cap.isOpened())
			break;
		
		if(isLive)
			cap >> frame;

		cv::Point2f srcTri[3];
		srcTri[0] = cv::Point2f( 0, 0 );
		srcTri[1] = cv::Point2f( frame.cols, 0 );
		srcTri[2] = cv::Point2f( 0, frame.rows );
		
		cv::Point2f dstTri[3];
		dstTri[0] = cv::Point2f( int(-out.cols * 0.1), 0 );
		dstTri[1] = cv::Point2f( int(out.cols-out.cols * 0.1), 0 );
		dstTri[2] = cv::Point2f( int(-out.cols * 0.1), out.rows );

		cv::Mat warp_mat = getAffineTransform( srcTri, dstTri );
		warpAffine( frame, out, warp_mat, out.size() );
		
		createColorSliders(out, bluLOW, bluHIG);

		cv::Mat ext = lsd::extract(frame, bluLOW, bluHIG).grayFrame;
		cv::resize(ext, ext, cv::Size(preview[0], preview[1]));
		cv::resize(out, out, cv::Size(preview[0], preview[1]));

		cv::imshow("Calibration", out);
		cv::imshow("BLUE Extracted",ext);

		//Mouse handling
		setColorRangesMouse(bluLOW,bluHIG,active,out);

		char c = (char)cv::waitKey(lsd::frameTime(30));
		if (c == 32)
			isLive ^= 1;
		if (c == 113 || c == 27)
			break;
	}
	cv::destroyWindow("BLUE Extracted");
	cv::destroyAllWindows();

}

int lsd::getAllVideoInputs()
{
	int iter = 0;
	std::vector <cv::VideoCapture> videovector;

	for (;;)
	{
		cv::VideoCapture capTmp(iter);
		if (capTmp.isOpened())
		{
			videovector.push_back(capTmp);
		}
		else
		{
			break;
		}

		iter++;
	}

	if (videovector.size() > 0)
	{
		bool end = false;
		while (!end)
		{
			for (int i = 0; i < videovector.size(); i++)
			{
				cv::Mat frame;
				videovector[i] >> frame;
				cv::resize(frame, frame, cv::Size(preview[0], preview[1]));
				cv::imshow(std::to_string(i), frame);

				char c = (char)cv::waitKey(frameTime(int(1000 / maxFRAMERATE)));
				if (int(c) == 113 || int(c) == 27)
				{
					end = true;
					break;
				}
			}
		}
	}
	cv::destroyAllWindows();
	return iter;
}

bool lsd::hasTimeExceeded(clock_t& start, clock_t& end, float timeLimit)
{
	return ((end - start) / CLOCKS_PER_SEC > timeLimit);
}

std::vector <windowsCoordinates> lsd::findWindowsByColor(cv::VideoCapture& cap, uint32_t min, uint32_t max)
{
	//PIWODEC2BGR
	cv::Scalar smin = PIWODEC2BGR(min);
	cv::Scalar smax = PIWODEC2BGR(max);
	return(findWindowsByColor(cap, smin, smax));
}

std::vector <windowsCoordinates> lsd::findWindowsByColor(cv::VideoCapture& cap, cv::Scalar& min, cv::Scalar& max)
{
	//twoDim
	std::vector <std::vector<cv::Mat> > mats;
	cv::Mat frame;
	cap >> frame;
	matMatrixAssigner(mats, frame, true);
	matMatrixAssigner(mats, frame);

	std::vector <windowsCoordinates>  output;

	for (int y = 0; y < mats.size(); y++)
	{
		for (int x = 0; x < mats[y].size(); x++)
		{
			mats[y][x] = extract(mats[y][x], min, max).grayFrame;
			if (matAverageValue(mats[y][x]) >= 128)
			{
				cv::Point coor(x, y);
				windowsCoordinates tmp;
				tmp.point = coor;

				tmp.window = twoDim[y][x];
				output.push_back(tmp);
			}
		}
	}
	return output;

}

uint32_t lsd::BGR2PIWODEC(cv::Scalar color)
{
	//BGR

	int r = int(color[2]) << 16;
	int b = int(color[1]) << 8;
	int g = int(color[0]);

	uint32_t output = r + g + b;
	return output;
}

cv::Scalar lsd::PIWODEC2BGR(uint32_t color)
{
	int r = color / (256 * 256);
	int g = (color / 256) % (256);
	int b = color % 256;

	cv::Scalar output(r, g, b);
	return output;
}

cv::Scalar lsd::windowAverageColor(cv::VideoCapture& cap, int x, int y)
{
	//Asserts for test
	assert(x >= 0 && x < windowsX);
	assert(y >= 0 && y < windowsY);
	assert(cap.isOpened());
	assert(isTransform);
	assert(twoDim.size() != 0);
	for (int i = 0; i < twoDim.size(); i++)
		assert(twoDim[i].size() != 0);

	//LSD error status report
	if(!(x >= 0 && x < windowsX))
		lsd::status = WRONG_GIVEN_COORDINATE_X;
	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	if(!(y >= 0 && y < windowsY))
		lsd::status = WRONG_GIVEN_COORDINATE_Y;
	if(!isTransform)
		lsd::status = NO_TRANSFORM_MATRIX_GENERATED;
	if(twoDim.size() == 0)
		lsd::status = EMPTY_WINDOW_ARRAY;
	for (int i = 0; i < twoDim.size(); i++)
	{
		if(twoDim.size() == 0)
			lsd::status = INCORRECT_WINDOW_ARRAY;
	}

	cv::Mat frame;
	cap >> frame;

	cv::warpPerspective(frame, frame, transformMat, cv::Size(frame.cols, frame.rows));


	cv::Rect maskData = windowMask(twoDim[y][x]);
	cv::Mat crop = cv::Mat::zeros(maskData.size(), frame.type());
	cv::Mat mask = cv::Mat::zeros(frame.size(), frame.type());
	cv::Mat cropMask = cv::Mat::zeros(maskData.size(), frame.type());

	cv::Point fillPts[4] = { twoDim[y][x].lUp, twoDim[y][x].rUp, twoDim[y][x].rDown, twoDim[y][x].lDown };
	cv::fillConvexPoly(mask, fillPts, 4, cv::Scalar(255, 255, 255));

	crop = frame(maskData).clone();
	cropMask = mask(maskData).clone();

	float r = 0, g = 0, b = 0;
	int num = 0;
	for (int y = 0; y < crop.rows; y++)
	{
		for (int x = 0; x < crop.cols; x++)
		{
			if (cropMask.at<cv::Vec3b>(y, x)[0] >= 128)
			{
				num++;
				cv::Vec3b color = crop.at<cv::Vec3b>(cv::Point(y, x));
				r += color[2];
				g += color[1];
				b += color[0];
			}
		}
	}
	if (num == 0)
	{
		status = WINDOW_SIZE_IS_ZERO;
		return cv::Scalar(-1, -1, -1);
	}
	return cv::Scalar(b / num, g / num, r / num);//BGR

}

void lsd::playTest(cv::VideoCapture& cap)
{
	cv::Mat frame;
	cap >> frame;

	std::cout << "Cap status: " << cap.isOpened() << std::endl;
	std::cout << "Frame status: " << !frame.empty() << std::endl;

	assert(cap.isOpened());
	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;

	while (!frame.empty())
	{
		cv::imshow("JustTest", frame);
		char c = (char)cv::waitKey(frameTime(int(1000 / maxFRAMERATE)));
			if (int(c) == 113 || int(c) == 27)
			{
				break;
			}
		cap >> frame;
	}
}

void lsd::webCamInfo(cv::VideoCapture& cap)
{
	cv::Mat frame;
	assert(cap.isOpened());
	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;

	int width, height, channels;
	double fps;
	cap.read(frame);
	width = frame.size().width;
	height = frame.size().height;
	channels = frame.channels();
	fps = cap.get(cv::CAP_PROP_FPS);

	std::cout << "==========Webcam info==========" << std::endl;
	std::cout << "Webcam width:          " << width << std::endl;
	std::cout << "Webcam height:         " << height << std::endl;
	std::cout << "Webcam color channels: " << channels << std::endl;
	std::cout << "Webcam FPS:            " << fps << std::endl;
	std::cout << "Frame ms:              " << float(1000 / fps) << std::endl;
	std::cout << "===============================" << std::endl;
}

void lsd::getWindowsCorners(int width, int height, std::vector< std::vector <cv::Point> >& wa, std::vector <windowCC>& wm)
{
	assert(width > 0);
	assert(height > 0);
	assert(wa.size() > 0);

	if(width <= 0)
		lsd::status = WRONG_DIMENSION_WIDTH;
	if(height <= 0)
		lsd::status = WRONG_DIMENSION_HEIGHT;
	if(wa.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;

	wm.clear();
	//Searching for the windows blobs Corners

	for (int i = 0; i < wa.size(); i++)
	{
		wm.push_back(windowCC()); //Empty var
		cornerSearch(width, height, wa[i], wm[i]); //Filled corners
		centreSearch(wm[i]); //Found centre
	}

}

void lsd::cornerSearch(int width, int height, std::vector <cv::Point>& pts, windowCC& wcc)
{
	assert(pts.size() >= 4);
	assert(width > 0);
	assert(height > 0);

	if(pts.size() < 4)
		lsd::status = NOT_ENOUGH_INPUT_DATA;
	if(width <= 0)
		lsd::status = WRONG_DIMENSION_WIDTH;
	if(height <= 0)
		lsd::status = WRONG_DIMENSION_HEIGHT;

	cv::Point tempPoints[4];

	int id[4] = { 0,0,0,0 };
	for (int i = 0; i < 4; i++)
		tempPoints[i] = pts[0];

	float distance[4];
	distance[0] = sqrt(pow((tempPoints[0].x), 2) + pow((tempPoints[0].y), 2));
	distance[1] = sqrt(pow((tempPoints[0].x - width), 2) + pow((tempPoints[0].y), 2));
	distance[2] = sqrt(pow((tempPoints[0].x - width), 2) + pow((tempPoints[0].y - height), 2));
	distance[3] = sqrt(pow((tempPoints[0].x), 2) + pow((tempPoints[0].y - height), 2));

	for (int i = 0; i < pts.size(); i++)
	{
		float localDistance[4];
		localDistance[0] = sqrt(pow((pts[i].x), 2) + pow((pts[i].y), 2));
		localDistance[1] = sqrt(pow((pts[i].x - width), 2) + pow((pts[i].y), 2));
		localDistance[2] = sqrt(pow((pts[i].x - width), 2) + pow((pts[i].y - height), 2));
		localDistance[3] = sqrt(pow((pts[i].x), 2) + pow((pts[i].y - height), 2));

		for (int j = 0; j < 4; j++)
		{
			if (localDistance[j] <= distance[j])
			{
				distance[j] = localDistance[j];
				id[j] = i;
			}
		}
	}

	wcc.lUp = pts[id[0]];
	wcc.rUp = pts[id[1]];
	wcc.rDown = pts[id[2]];
	wcc.lDown = pts[id[3]];
}

void lsd::centreSearch(windowCC& wcc)
{
	float x, y;
	x = (wcc.lUp.x + wcc.rUp.x + wcc.rDown.x + wcc.lDown.x) / 4;
	y = (wcc.lUp.y + wcc.rUp.y + wcc.rDown.y + wcc.lDown.y) / 4;
	cv::Point localCentre;
	localCentre.x = int(x);
	localCentre.y = int(y);
	wcc.centre = localCentre;
}

cv::Point lsd::centreSearch(windowB& wb)
{
	assert(wb.windowBorder.size() > 0);
	if(wb.windowBorder.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;

	float x = 0;
	float y = 0;

	int len = wb.windowBorder.size();

	for (int i = 0; i < len; i++)
	{
		x += wb.windowBorder[i].x;
		y += wb.windowBorder[i].y;
	}

	x /= len;
	y /= len;

	cv::Point localCentre;
	localCentre.x = int(x);
	localCentre.y = int(y);
	return localCentre;
}

frameCnts lsd::extract(cv::Mat frame, cv::Scalar colour_Low, cv::Scalar colour_High)
{
	assert(!frame.empty());
	if(frame.empty())
		lsd::status = NO_INPUT_DETECTED;

	if (lsd::windowsX != 1) lsd::dConst = sqrt(pow(float(frame.cols) / float(lsd::windowsX), 2) + pow(float(frame.rows) / float(lsd::windowsY), 2)) / (sqrt(float(12)));
	cv::Mat frameCopy = frame.clone();
	std::vector< std::vector <cv::Point> > contours;
	//Blur
	cv::blur(frameCopy, frameCopy, cv::Size(4, 4));
	cv::GaussianBlur(frameCopy, frameCopy, cv::Size(5, 5), 0);
	cv::GaussianBlur(frameCopy, frameCopy, cv::Size(5, 5), 0);
	//Color threshold
	cv::threshold(frameCopy, frameCopy, threshLvlLow, threshLvlHigh, 0);
	//Blur
	cv::GaussianBlur(frameCopy, frameCopy, cv::Size(5, 5), 0);
	cv::GaussianBlur(frameCopy, frameCopy, cv::Size(5, 5), 0);
	//Artiffacts removal
	cv::erode(frameCopy, frameCopy, NULL, cv::Point(-1, -1), 1);
	cv::dilate(frameCopy, frameCopy, NULL, cv::Point(-1, -1), 2);
	//Choosing one color; removing rest
	cv::inRange(frameCopy, colour_Low, colour_High, frameCopy);
	//Blur
	cv::GaussianBlur(frameCopy, frameCopy, cv::Size(5, 5), 0);
	//Thresh binary (Instead BGR or HCV -> Boolian)
	cv::threshold(frameCopy, frameCopy, 155, 255, 0);
	//Artiffacts removal
	cv::erode(frameCopy, frameCopy, NULL, cv::Point(-1, -1), 1);
	cv::dilate(frameCopy, frameCopy, NULL, cv::Point(-1, -1), 2);
	//Blur
	cv::GaussianBlur(frameCopy, frameCopy, cv::Size(5, 5), 0);
	cv::threshold(frameCopy, frameCopy, 10, 255, 0);
	std::vector<cv::Vec4i> hierarchy;
	cv::findContours(frameCopy, contours, hierarchy, cv::RETR_TREE, cv::CHAIN_APPROX_SIMPLE, cv::Point(0, 0));//Check if works
	frameCnts output;
	output.grayFrame = frameCopy;
	output.windowBorder = contours;

	return output;

}

void lsd::BGRtoHSV(int* BGRbase, float* HSV)
{
	float BGR[3];
	//https://www.programmingalgorithms.com/algorithm/rgb-to-hsv/cpp/
	//B,G,R <0-255>
	//H <0-360>, S,V <0-1>
	float H, S, V;
	for (int i = 0; i < 3; i++) BGR[i] = float(BGRbase[i]) / 255;

	float delta, minm;
	float h = 0, s, v;

	minm = std::min(std::min(BGR[2], BGR[1]), BGR[0]);
	v = std::max(std::max(BGR[2], BGR[1]), BGR[0]);
	delta = v - minm;

	if (v == 0.0)
		s = 0;
	else
		s = delta / v;

	if (s == 0)
		h = 0.0;

	else
	{
		if (BGR[2] == v)
			h = (BGR[1] - BGR[0]) / delta;
		else if (BGR[1] == v)
			h = 2 + (BGR[0] - BGR[2]) / delta;
		else if (BGR[0] == v)
			h = 4 + (BGR[2] - BGR[1]) / delta;

		h *= 60;

		if (h < 0.0)
			h = h + 360;
	}

	HSV[0] = h;
	HSV[1] = s;
	HSV[2] = v;
}

frameCnts lsd::cummulation(std::vector <std::vector <cv::Mat> >& matList, std::vector <cv::Scalar>& color_Low, std::vector <cv::Scalar>& color_High)
{
	assert(matList.size() > 0);
	for (int i = 0; i < matList.size(); i++)
		assert(matList[i].size() > 0);
	assert(matList.size() == color_Low.size());
	assert(matList.size() == color_High.size());

	if(matList.size() == 0)
		lsd::status = EMPTY_MAT_ARRAY;
	
	for (int i = 0; i < matList.size(); i++)
	{
		if(matList[i].size() == 0);
			lsd::status = INCORRECT_MAT_ARRAY;
	}

	if(matList.size() != color_Low.size())
		lsd::status = WRONG_COLORSPACE_SIZE;
	if(matList.size() != color_High.size())
		lsd::status = WRONG_COLORSPACE_SIZE;

	cv::Mat finalMat;
	std::vector <cv::Mat> BGRs;

	for (int color = 0; color < matList.size(); color++)
	{
		std::vector <cv::Mat> tmp;
		for (int repeat = 0; repeat < matList[color].size(); repeat++)
		{
			cv::Mat tmp2 = matList[color][repeat];
			cv::Mat tmp4 = extract(tmp2, color_Low[color], color_High[color]).grayFrame;
			tmp.push_back(tmp4);
		}
		cv::Mat colorMat = tmp[0];
		if (!tmp.size() == 1)
		{
			for (int i = 1; i < tmp.size(); i++)
			{
				cv::Mat tmpCopy;
				cv::bitwise_and(colorMat, tmp[i], tmpCopy);
				colorMat = tmpCopy.clone();
			}
		}
		BGRs.push_back(colorMat);
	}

	assert(BGRs.size() > 0);
	if(BGRs.size() == 0)
		lsd::status = BGR_TABLE_EMPTY;

	finalMat = BGRs[0];
	if (BGRs.size() != 1)
	{
		for (int i = 1; i < BGRs.size(); i++)
		{
			cv::Mat tmpCopy;
			cv::bitwise_and(finalMat, BGRs[i], tmpCopy);
			finalMat = tmpCopy.clone();
		}
	}

	std::vector<cv::Vec4i> hierarchy;
	std::vector< std::vector <cv::Point> > contours;
	cv::findContours(finalMat, contours, hierarchy, cv::RETR_TREE, cv::CHAIN_APPROX_SIMPLE, cv::Point(0, 0));//Check if works
	frameCnts output;
	output.grayFrame = finalMat;
	output.windowBorder = contours;

	return output;
}

void lsd::deleteWindows(std::vector <windowCC>& windowList, cv::Mat frame)
{
	assert(!frame.empty());
	if(frame.empty())
		lsd::status = NO_INPUT_DETECTED;

	std::vector <windowCC> deletedList;
	cv::Mat bcg(frame.rows, frame.cols, CV_8UC3, cv::Scalar(0, 0, 0));
	cv::Point pt0, pt1, pt2;
	pt0.y = frame.rows / 2;
	pt0.x = 20;
	pt1.y = frame.rows / 2 + 25;
	pt1.x = 20;
	pt2.y = frame.rows / 2 + 50;
	pt2.x = 20;
	cv::putText(bcg, "To start selecting wrong windows, press 'u'", pt0, cv::FONT_HERSHEY_SIMPLEX, 1, cv::Scalar(200, 255, 200));
	cv::putText(bcg, "To cancel or finish, press 'q'", pt1, cv::FONT_HERSHEY_SIMPLEX, 1, cv::Scalar(200, 200, 255));

	cv::resize(bcg, bcg, cv::Size(preview[0], preview[1]));
	cv::imshow("LSD Windows deletion tool", bcg);
	cv::waitKey(0);
	cv::setMouseCallback("LSD Windows deletion tool", onMouse, 0);
	mouse.endPress = false;
	mouse.startPress = false;


	for (;;)
	{
		cv::Mat frameCopy = frame.clone();

		if (mouse.endPress && mouse.startPress)
		{
			if (mouse.endPoint.x < mouse.startPoint.x)
			{
				int pomx = mouse.endPoint.x;
				mouse.endPoint.x = mouse.startPoint.x;
				mouse.startPoint.x = pomx;
			}
			if (mouse.endPoint.y < mouse.startPoint.y)
			{
				int pomy = mouse.endPoint.y;
				mouse.endPoint.y = mouse.startPoint.y;
				mouse.startPoint.y = pomy;
			}

			mouse.startPoint = calculateResizedPossition(mouse.startPoint, frame);
			mouse.endPoint = calculateResizedPossition(mouse.endPoint, frame);

			for (int i = 0; i < windowList.size(); i++)
			{
				if (windowList[i].centre.x > mouse.startPoint.x && windowList[i].centre.x < mouse.endPoint.x)
				{
					if (windowList[i].centre.y > mouse.startPoint.y && windowList[i].centre.y < mouse.endPoint.y)
					{
						deletedList.push_back(windowList[i]);
						windowList.erase(windowList.begin() + i);
						break;
					}
				}
			}

			mouse.endPress = false;
			mouse.startPress = false;
		}

		for (int i = 0; i < windowList.size(); i++)
			windowPainter(frameCopy, windowList[i], cv::Scalar(255, 255, 255));

		for (int i = 0; i < deletedList.size(); i++)
			windowPainter(frameCopy, deletedList[i], cv::Scalar(0, 0, 255));

		cv::resize(frameCopy, frameCopy, cv::Size(preview[0], preview[1]));
		cv::imshow("LSD Windows deletion tool", frameCopy);
		char c = (char)cv::waitKey(30);
		if (c == 113 || c == 27)
			break;
	}
	cv::destroyAllWindows();
}

void lsd::addWindows(std::vector <windowCC>& windowList, cv::Mat frame)
{
	assert(!frame.empty());
	if(frame.empty())
		lsd::status = NO_INPUT_DETECTED;

	std::vector <windowCC> addedList;
	cv::Mat bcg(frame.rows, frame.cols, CV_8UC3, cv::Scalar(0, 0, 0));
	cv::Point pt0, pt1, pt2;
	pt0.y = frame.rows / 2;
	pt0.x = 20;
	pt1.y = frame.rows / 2 + 25;
	pt1.x = 20;
	pt2.y = frame.rows / 2 + 50;
	pt2.x = 20;
	cv::putText(bcg, "To start adding windows, press 'u'", pt0, cv::FONT_HERSHEY_SIMPLEX, 1, cv::Scalar(200, 255, 200));
	cv::putText(bcg, "To cancel or finish, press 'q'", pt1, cv::FONT_HERSHEY_SIMPLEX, 1, cv::Scalar(200, 200, 255));
	cv::putText(bcg, "To undo, press 'z'", pt2, cv::FONT_HERSHEY_SIMPLEX, 1, cv::Scalar(255, 200, 200));

	cv::resize(bcg, bcg, cv::Size(preview[0], preview[1]));
	cv::imshow("LSD Windows addition tool", bcg);
	cv::setMouseCallback("LSD Windows addition tool", onMouse, 0);
	cv::waitKey(0);

	for (;;)
	{
		cv::Mat frameCopy = frame.clone();

		if (mouse.endPress && mouse.startPress)
		{
			std::vector <cv::Point> tmp;
			tmp.push_back(calculateResizedPossition(mouse.startPoint, frame));
			tmp.push_back(calculateResizedPossition(mouse.endPoint, frame));
			tmp.push_back(calculateResizedPossition(cv::Point(mouse.startPoint.x, mouse.endPoint.y), frame));
			tmp.push_back(calculateResizedPossition(cv::Point(mouse.endPoint.x, mouse.startPoint.y), frame));

			windowCC pb;
			cornerSearch(frame.cols, frame.rows, tmp, pb);
			centreSearch(pb);
			addedList.push_back(pb);
			mouse.endPress = false;
			mouse.startPress = false;
		}

		for (int i = 0; i < windowList.size(); i++)
			windowPainter(frameCopy, windowList[i], cv::Scalar(255, 255, 255));

		for (int i = 0; i < addedList.size(); i++)
			windowPainter(frameCopy, addedList[i], cv::Scalar(0, 255, 0));

		cv::resize(frameCopy, frameCopy, cv::Size(preview[0], preview[1]));
		cv::imshow("LSD Windows addition tool", frameCopy);
		char c = (char)cv::waitKey(30);
		if (c == 113 || c == 27)
			break;
		if (c == 122 && addedList.size() > 0)
			addedList.erase(addedList.begin() + addedList.size() - 1);
	}
	windowList.insert(windowList.end(), addedList.begin(), addedList.end());
	cv::destroyAllWindows();
}

void lsd::chooseCorners(std::vector <windowCC>& windowList, cv::Mat frame)
{
	assert(!frame.empty());
	assert(windowList.size() >= 4);

	if(frame.empty())
		lsd::status = NO_INPUT_DETECTED;
	if(windowList.size() < 4)
		lsd::status = NOT_ENOUGH_WINDOWS_TO_CHOOSE_CORNERS;

	cv::Mat bcg(frame.rows, frame.cols, CV_8UC3, cv::Scalar(0, 0, 0));
	cv::Point pt0, pt1;
	pt0.y = frame.rows / 2;
	pt0.x = 20;
	pt1.y = frame.rows / 2 + 25;
	pt1.x = 20;
	cv::putText(bcg, "To start choosing windows, press 'u'", pt0, cv::FONT_HERSHEY_SIMPLEX, 1, cv::Scalar(200, 255, 200));
	cv::putText(bcg, "To apply or finish, press 'q'", pt1, cv::FONT_HERSHEY_SIMPLEX, 1, cv::Scalar(200, 200, 255));;

	cv::resize(bcg, bcg, cv::Size(preview[0], preview[1]));
	cv::imshow("LSD Corner Selection tool", bcg);
	cv::setMouseCallback("LSD Corner Selection tool", onMouse, 0);
	cv::waitKey(0);

	getWindowsPerspective(frame.cols, frame.rows, windowList);
	isTransform = true;

	for (;;)
	{
		cv::Mat frameCopy = frame.clone();

		for (int i = 0; i < windowList.size(); i++)
			windowPainter(frameCopy, windowList[i], cv::Scalar(200, 200, 200));

		for (int i = 0; i < 4; i++)
			cv::circle(frameCopy, inptQ[i], 3, cv::Scalar(0, 255, 255), 2);

		cv::resize(frameCopy, frameCopy, cv::Size(preview[0], preview[1]));

		cv::imshow("LSD Corner Selection tool", frameCopy);

		if (mouse.startPress)
		{
			mouse.startPoint = calculateResizedPossition(mouse.startPoint, frame);

			float minm = sqrt(pow(frame.cols, 2) + pow(frame.rows, 2));
			int idm = -1;
			for (int i = 0; i < windowList.size(); i++)
			{
				float localD = pointsDistance(windowList[i].centre, mouse.startPoint);
				if (localD < dConst && localD < minm)
				{
					minm = localD;
					idm = i;
				}
			}

			if (idm != -1)
			{
				//operating on windowList[idm].centre

				if (windowList[idm].centre.x <= frame.cols / 2)
				{
					if (windowList[idm].centre.y <= frame.rows / 2)
					{
						inptQ[0] = windowList[idm].lUp;
						inptQ[0].x -= dConst / 3;
						inptQ[0].y -= dConst / 3;
					}
					else if (windowList[idm].centre.y > frame.rows / 2)
					{
						inptQ[3] = windowList[idm].lDown;
						inptQ[3].x -= dConst / 3;
						inptQ[3].y += dConst / 3;
					}
				}
				else if (windowList[idm].centre.x > frame.cols / 2)
				{
					if (windowList[idm].centre.y <= frame.rows / 2)
					{
						inptQ[1] = windowList[idm].rUp;
						inptQ[1].x += dConst / 3;
						inptQ[1].y -= dConst / 3;
					}
					else if (windowList[idm].centre.y > frame.rows / 2)
					{
						inptQ[2] = windowList[idm].rDown;
						inptQ[2].x += dConst / 3;
						inptQ[2].y += dConst / 3;
					}
				}
			}

			mouse.startPress = false;
		}


		char c = (char)cv::waitKey(30);
		if (c == 113 || c == 27)
			break;
	}
	cv::destroyAllWindows();

	transformMat = cv::getPerspectiveTransform(inptQ, outpQ);
}

void lsd::windowPainter(cv::Mat& frame, windowCC& window, cv::Scalar color)
{
	assert(!frame.empty());
	if(frame.empty())
		lsd::status = NO_INPUT_DETECTED;

	cv::circle(frame, window.centre, 1, cv::Scalar(255, 255, 255), 1);

	cv::circle(frame, window.lUp, 1, cv::Scalar(0, 0, 255), 1);
	cv::circle(frame, window.rUp, 1, cv::Scalar(0, 255, 0), 1);
	cv::circle(frame, window.rDown, 1, cv::Scalar(255, 0, 0), 1);
	cv::circle(frame, window.lDown, 1, cv::Scalar(0, 255, 255), 1);

	cv::line(frame, window.lUp, window.rUp, color, 1);
	cv::line(frame, window.rDown, window.rUp, color, 1);
	cv::line(frame, window.rDown, window.lDown, color, 1);
	cv::line(frame, window.lUp, window.lDown, color, 1);
}

void lsd::getWindowsPerspective(int width, int height, std::vector <windowCC>& windowList)
{
	assert(width > 0);
	assert(height > 0);

	if(width <= 0)
		lsd::status = WRONG_DIMENSION_WIDTH;
	if(height <= 0)
		lsd::status = WRONG_DIMENSION_HEIGHT;
	//assert(windowList.size() >= 4);

	if (lsd::windowsX != 1)
		lsd::dConst = sqrt(pow(float(width) / float(lsd::windowsX), 2) + pow(float(width) / float(lsd::windowsY), 2)) / (sqrt(float(6)));
	//from getWindowsPerspective we get four points (do not mind centre)
	//To apply transform we need another four points, which are
	//frame corners

	std::vector <cv::Point> temp;

	for (int i = 0; i < windowList.size(); i++)
	{
		temp.push_back(windowList[i].lUp);
		temp.push_back(windowList[i].rUp);
		temp.push_back(windowList[i].rDown);
		temp.push_back(windowList[i].lDown);
	}

	windowCC output;
	cornerSearch(width, height, temp, output);

	output.lUp.x -= dConst / 3;
	output.lUp.y -= dConst / 3;
	output.rUp.x += dConst / 3;
	output.rUp.y -= dConst / 3;
	output.rDown.x += dConst / 3;
	output.rDown.y += dConst / 3;
	output.lDown.x -= dConst / 3;
	output.lDown.y += dConst / 3;

	output.centre.x = -2;
	output.centre.y = -2;

	inptQ[0] = output.lUp;
	inptQ[1] = output.rUp;
	inptQ[2] = output.rDown;
	inptQ[3] = output.lDown;

	cv::Point tmpPoint;
	tmpPoint.x = 0;
	tmpPoint.y = 0;
	outpQ[0] = tmpPoint;
	tmpPoint.x = width;
	tmpPoint.y = 0;
	outpQ[1] = tmpPoint;
	tmpPoint.x = width;
	tmpPoint.y = height;
	outpQ[2] = tmpPoint;
	tmpPoint.x = 0;
	tmpPoint.y = height;
	outpQ[3] = tmpPoint;

	transformMat = cv::getPerspectiveTransform(inptQ, outpQ);
}

void lsd::camPrevShow(cv::VideoCapture& cap, bool appliedTransform)
{
	if (appliedTransform)
		assert(transformMatrix.centre.x != -1);
		if(transformMatrix.centre.x == -1)
			lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	assert(cap.isOpened());
	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;

	cv::Mat frame;

	for (;;)
	{
		cap >> frame;
		if (frame.empty())
			break;

		if (appliedTransform)
			frame = cv::getPerspectiveTransform(inptQ, outpQ);

		cv::resize(frame, frame, cv::Size(preview[0], preview[1]));

		cv::imshow("LSD webcam feed", frame);
		char c = (char)cv::waitKey(int(1000 / cap.get(cv::CAP_PROP_FPS)));
		if (c == 113 || c == 27)
			break;
	}
	cv::destroyAllWindows();
}

std::vector <windowCC> lsd::calibration(std::vector <std::vector <cv::Mat> >& windowMats, std::vector <cv::Scalar>& color_Low, std::vector <cv::Scalar>& color_High, int width, int height)
{
	assert(windowMats.size() > 0);
	for (int i = 0; i < windowMats.size(); i++)
		assert(windowMats[i].size() > 0);

	if(windowMats.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;
	for (int i = 0; i < windowMats.size(); i++)
	{
		if(windowMats[i].size() == 0)
			lsd::status = INCORRECT_ARRAY;
	}

	std::vector <windowCC> output;

	std::vector <std::vector <cv::Point> > cummulatedPoints = cummulation(windowMats, color_Low, color_High).windowBorder;

	getWindowsCorners(width, height, cummulatedPoints, output);
	return output;
}

void lsd::vvp2vwb(std::vector <std::vector <cv::Point> >& points, std::vector <windowB>& winB)
{
	assert(points.size() > 0);
	if(points.size() == 0)
		lsd::status = NO_INPUT_DETECTED;

	for (int i = 0; i < points.size(); i++)
		assert(points[i].size() > 0);

	winB.clear();

	for (int i = 0; i < points.size(); i++)
	{
		windowB tmp;
		tmp.windowBorder = points[i];
		winB.push_back(tmp);
	}
}

void lsd::vwb2vvp(std::vector <windowB>& winB, std::vector <std::vector <cv::Point> >& points)
{
	assert(winB.size() > 0);
	if(winB.size() == 0)
		lsd::status = NO_INPUT_DETECTED;

	for (int i = 0; i < winB.size(); i++)
		assert(winB[i].windowBorder.size() > 0);

	points.clear();

	for (int i = 0; i < winB.size(); i++)
	{
		std::vector <cv::Point> tmp;
		tmp = winB[i].windowBorder;
		points.push_back(tmp);
	}
}

void lsd::arrayTo2DArray(std::vector <windowCC>& windowList)
{
	assert(windowList.size() == windowsX * windowsY);
	if(windowList.size() != windowsX * windowsY)
		lsd::status = WRONG_WINDOW_AMOUNT;

	std::vector <std::vector <windowCC> > outputMatrix;
	std::sort(windowList.begin(), windowList.end(), sortByY);

	for (int y = 0; y < windowsY; y++)
	{
		std::vector <windowCC> temp;
		for (int x = 0; x < windowsX; x++)
			temp.push_back(windowList[y * windowsX + x]);
		outputMatrix.push_back(temp);
		std::sort(outputMatrix[y].begin(), outputMatrix[y].end(), sortByX);
	}

	twoDim = outputMatrix;
}

bool lsd::sortByX(windowCC a, windowCC b)
{
	return (a.centre.x < b.centre.x);
}

bool lsd::sortByY(windowCC a, windowCC b)
{
	return (a.centre.y < b.centre.y);
}

frameColorInfo lsd::isColorFromFeed(cv::Mat frame, cv::Scalar baseMat, float sensR, float sensG, float sensB)
{
	assert(!frame.empty());
	assert(sensR > 0);
	assert(sensG > 0);
	assert(sensB > 0);

	if(frame.empty())
		lsd::status = NO_INPUT_DETECTED;
	if(sensR <= 0)
		lsd::status = WRONG_COLOR_THRESHOLD_LVL;
	if(sensG <= 0)
		lsd::status = WRONG_COLOR_THRESHOLD_LVL;
	if(sensB <= 0)
		lsd::status = WRONG_COLOR_THRESHOLD_LVL;

	frameColorInfo output;
	cv::Mat base[3];
	base[0] = extract(frame, cv::Scalar(0, 0, 64), cv::Scalar(5, 5, 255)).grayFrame;//Red
	base[1] = extract(frame, cv::Scalar(0, 64, 0), cv::Scalar(16, 255, 16)).grayFrame;//Green
	base[2] = extract(frame, cv::Scalar(64, 0, 0), cv::Scalar(255, 16, 16)).grayFrame;//Blue

	float averages[3];

	for (int i = 0; i < 3; i++)
		averages[i] = matAverageValue(base[i]);

	output.colorMat = cv::Scalar(averages[0], averages[1], averages[2]);

	if (baseMat[0] == -1)
		return output;

	if (averages[0] - baseMat[0] > sensR)
	{
		output.anyColors = true;
		output.red = true;
	}
	if (averages[1] - baseMat[1] > sensG)
	{
		output.anyColors = true;
		output.green = true;
	}
	if (averages[2] - baseMat[2] > sensB)
	{
		output.anyColors = true;
		output.blue = true;
	}
	return output;
}

float lsd::matAverageValue(cv::Mat& frame)
{
	assert(!frame.empty());
	if(frame.empty())
		lsd::status = NO_INPUT_DETECTED;

	double val = 0;

	cv::Scalar val1 = cv::mean(frame);
	for (int c = 0; c < frame.channels(); c++)
		val += val1[c];
	return (val / frame.channels());
}

float lsd::windowColorAccuracy(colorLibrary differentColors, std::vector <cv::Scalar>& thLow, std::vector<cv::Scalar>& thHigh)
{
	assert(!differentColors.red.empty());
	assert(!differentColors.green.empty());
	assert(!differentColors.blue.empty());
	std::cout <<"D0" << std::endl;
	if(differentColors.red.empty() || differentColors.green.empty() || differentColors.blue.empty())
		lsd::status = NOT_ENOUGH_INPUT_DATA;

	double val = 0;
	int amount = 0;

	cv::Mat toSplit[3];

	cv::split(differentColors.red,toSplit);
	cv::Mat frameR = toSplit[2];
	cv::split(differentColors.green,toSplit);
	cv::Mat frameG = toSplit[1];
	cv::split(differentColors.blue,toSplit);
	cv::Mat frameB = toSplit[0];
	if(! (frameR.cols == frameG.cols == frameB.cols))
		lsd::status = INPUTS_SIZES_NOT_MATCH;
	if(! (frameR.rows == frameG.rows == frameB.rows))
		lsd::status = INPUTS_SIZES_NOT_MATCH;

	if(frameR.empty() || frameG.empty() || frameB.empty())
		lsd::status = NO_INPUT_DETECTED;
	for(int y = 0; y < frameR.rows; y++)
	{
		for(int x = 0; x < frameR.cols; x++)
		{
			double locfin = 0;
			int valR = frameR.at<cv::Vec3b>(y,x)[2];
			int valG = frameG.at<cv::Vec3b>(y,x)[1];
			int valB = frameB.at<cv::Vec3b>(y,x)[0];

			if(valR >= 1 && valG >= 1 && valB >= 1)
			{
				amount++;
				if(valR < thLow[0][2] || valR > thHigh[0][2])
					locfin = 0;
				else if(valG < thLow[1][1] || valR > thHigh[1][1])
					locfin = 0;
				else if(valB < thLow[2][0] || valR > thHigh[2][0])
					locfin = 0;
				else
				{
					double calR = pow(valR-(thHigh[0][2]-thLow[0][2])/2,2)/5;
					double calG = pow(valG-(thHigh[1][1]-thLow[1][1])/2,2)/5;
					double calB = pow(valB-(thHigh[2][0]-thLow[2][0])/2,2)/5;

					val += 255-pow(calR+calG+calB,0.5);
				}
			}
		}
	}
	if(amount == 0)
		return 0;
	return(val/(amount*255));
	
}

std::vector <windowCC> lsd::deleteArtiffacts(std::vector <windowCC>& windowList)
{
	assert(windowList.size() > 0);
	if(windowList.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;

	std::vector <windowCC> output;
	//Average distance between corner points (0-2, 1-3)
	float averageDiagonal0 = 0;
	float averageDiagonal1 = 0;
	float averageDiagonal = 0;
	float uncertanity = 0;

	for (int i = 0; i < windowList.size(); i++)
	{
		averageDiagonal0 += pointsDistance(windowList[i].lUp, windowList[i].rDown);
		averageDiagonal1 += pointsDistance(windowList[i].rUp, windowList[i].lDown);
	}
	averageDiagonal0 /= windowList.size();
	averageDiagonal1 /= windowList.size();

	//Average distance between diagonal points with uncertanity
	averageDiagonal = sqrt(pow(averageDiagonal0, 2) + pow(averageDiagonal1, 2));
	//If still remains a lot of artiffacts, can change sqrt value to higher (3 is default)
	uncertanity = averageDiagonal0 / sqrt(1);

	//Checking if every window on list fulfills needs (av - av*sqrt(3) < d < av + av*sqrt(3))
	for (int i = 0; i < windowList.size(); i++)
	{
		float tmpDiag0 = pointsDistance(windowList[i].lUp, windowList[i].rDown);
		float tmpDiag1 = pointsDistance(windowList[i].rUp, windowList[i].lDown);
		float tmpDiag = sqrt(pow(tmpDiag0, 2) + pow(tmpDiag1, 2));

		if (tmpDiag > (averageDiagonal - uncertanity) && tmpDiag < (averageDiagonal + uncertanity))
			output.push_back(windowList[i]);
	}

	//If two window centres are to close to each other (d < dConst) one of them shall be erased
	for (int i = 0; i < output.size(); i++)
	{
		for (int j = 0; j < output.size(); j++)
		{
			if (i != j)
			{
				float temp = pointsDistance(output[i].centre, output[j].centre);
				if (temp < dConst)
					output.erase(output.begin() + j);
			}
		}
	}
	return output;
}

float lsd::pointsDistance(cv::Point& a, cv::Point& b)
{
	return float(sqrt(pow(a.x - b.x, 2) + pow(a.y - b.y, 2)));
}

cv::Point lsd::calculateResizedPossition(cv::Point pt, cv::Mat& source)
{
	cv::Point np;
	np.x = pt.x * (float(source.cols) / float(preview[0]));
	np.y = pt.y * (float(source.rows) / float(preview[1]));
	return np;
}

void lsd::rect2windowsCC(std::vector <cv::Rect>& r, std::vector <windowCC>& w)
{
	assert(r.size() > 0);

	if(r.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;


	w.clear();
	for (int i = 0; i < r.size(); i++)
	{
		windowCC temp;
		temp.lUp = r[i].tl();
		temp.rUp = cv::Point(r[i].tl().x + r[i].size().width, r[i].tl().y);
		temp.rDown = cv::Point(r[i].tl().x + r[i].size().width, r[i].tl().y + r[i].size().height);
		temp.lDown = cv::Point(r[i].tl().x, r[i].tl().y + r[i].size().height);
		centreSearch(temp);
		w.push_back(temp);
	}
}

void lsd::firstStep(cv::VideoCapture& cap, float time)
{
	assert(cap.isOpened());
	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	int step = 0;
	float ms = 1000 / cap.get(cv::CAP_PROP_FPS);
	cv::Mat frame;
	cap >> frame;
	const cv::Mat prevStatic = frame.clone();

	std::vector <std::vector <cv::Mat> > colouredFrames;
	std::vector <cv::Mat> temp;
	for (int i = 0; i < 3; i++) colouredFrames.push_back(temp);

	frameColorInfo defaultColorInfo = isColorFromFeed(frame, cv::Scalar(-1, -1, -1));
	//LibPiwo communication, request to light up every window in RGB pattern
	//Later to change; use customizable patterns
	std::cout << "<LSD>[Inf] Awaiting signals" << std::endl;

	clock_t begin = clock();
	for (;;)
	{
		int sum = 0;
		for (int i = 0; i < 3; i++)
			sum += colouredFrames[i].size();

		if (sum == calibrationAccuracy * 3)//Everything received
			break;

		if (step == 4)
			break;

		if (!cap.isOpened())
			break;

		cap >> frame;

		if (frame.empty())
			break;

		frameColorInfo localColorInfo = isColorFromFeed(frame, defaultColorInfo.colorMat);

		if (localColorInfo.anyColors)
		{
			if (schematic[step] == 0)//Red
			{
				if ((localColorInfo.red) && (!localColorInfo.green) && (!localColorInfo.blue))
				{
					if (colouredFrames[0].size() < calibrationAccuracy)
						colouredFrames[0].push_back(frame.clone());
					else step++;
				}
			}
			if (schematic[step] == 1)//Green
			{
				if ((!localColorInfo.red) && (localColorInfo.green) && (!localColorInfo.blue))
				{
					if (colouredFrames[1].size() < calibrationAccuracy)
						colouredFrames[1].push_back(frame.clone());
					else step++;
				}
			}
			if (schematic[step] == 2)//Blue
			{
				if ((!localColorInfo.red) && (!localColorInfo.green) && (localColorInfo.blue))
				{
					if (colouredFrames[2].size() < calibrationAccuracy)
						colouredFrames[2].push_back(frame.clone());
					else step++;
				}
			}
		}

		if (colouredFrames[0].size() > 0)
		{
			cv::Mat tmpFrame0 = colouredFrames[0][0];
			cv::resize(tmpFrame0, tmpFrame0, cv::Size(preview[0] / 3, preview[1] / 3));
			cv::imshow("<LSD> Colour 0 preview", tmpFrame0);
		}
		if (colouredFrames[1].size() > 0)
		{
			cv::Mat tmpFrame0 = colouredFrames[1][0];
			cv::resize(tmpFrame0, tmpFrame0, cv::Size(preview[0] / 3, preview[1] / 3));
			cv::imshow("<LSD> Colour 1 preview", tmpFrame0);
		}
		if (colouredFrames[2].size() > 0)
		{
			cv::Mat tmpFrame0 = colouredFrames[2][0];
			cv::resize(tmpFrame0, tmpFrame0, cv::Size(preview[0] / 3, preview[1] / 3));
			cv::imshow("<LSD> Colour 2 preview", tmpFrame0);
		}

		cv::Mat scaled = frame.clone();
		cv::resize(scaled, scaled, cv::Size(preview[0], preview[1]));
		cv::imshow("<LSD> Webcam Feed", scaled);

		char c = (char)cv::waitKey(frameTime(int(ms)));
		if (c == 113 || c == 27)
			break;
		clock_t timeStamp = clock();
		if (hasTimeExceeded(begin, timeStamp, time) && !testBool)
		{
			status = TIME_EXCEEDED;
			return;
		}
	}
	cv::destroyAllWindows();
	assert((colouredFrames[0].size() + colouredFrames[1].size() + colouredFrames[2].size()) == (calibrationAccuracy * 3));
	//Here add change-color-sequence, repeat prev.


	std::vector <windowCC> corneredWindows = calibration(colouredFrames, lsd::colLow, lsd::colHigh, prevStatic.cols, prevStatic.rows);
	std::vector <windowCC> unartifacted = deleteArtiffacts(corneredWindows);//In case of not finding windows; delete

	cv::Mat windowsWithShapes = prevStatic.clone();

	for (int i = 0; i < unartifacted.size(); i++)
		windowPainter(windowsWithShapes, unartifacted[i], cv::Scalar(255, 255, 255));

	cv::resize(windowsWithShapes, windowsWithShapes, cv::Size(preview[0], preview[1]));
	cv::imshow("<LSD> Windows found", windowsWithShapes);
	cv::waitKey(0);
	cv::destroyAllWindows();

	deleteWindows(unartifacted, prevStatic.clone());
	addWindows(unartifacted, prevStatic.clone());
	chooseCorners(unartifacted, prevStatic.clone());
	cv::destroyAllWindows();

	//getWindowsPerspective(frame.cols, frame.rows,unartifacted);
	//We finally get points for perspective transform
}

void lsd::firstStep(cv::VideoCapture& cap, std::string cascadeName)
{
	assert(cap.isOpened());
	assert(cascadeName.size() > 0);

	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	if(cascadeName.size() == 0)
		lsd::status = WRONG_CASCADE_NAME;

	cv::CascadeClassifier window_cascade;
	bool loaded = window_cascade.load(cascadeName);
	assert(loaded);

	if(!loaded)
		lsd::status = CASCADE_NOT_LOADED;

	float ms = 1000 / cap.get(cv::CAP_PROP_FPS);
	cv::Mat frame;
	cap >> frame;
	const cv::Mat prevStatic = frame.clone();

	std::vector<cv::Rect> haarWindows;
	std::vector<windowCC> newWindows;

	std::cout << "<LSD>[Inf] Awaiting signals" << std::endl;

	for (;;)
	{
		if (!cap.isOpened())
			break;

		cap >> frame;

		if (frame.empty())
			break;

		cv::Mat gray;
		cv::cvtColor(frame, gray, cv::COLOR_BGR2GRAY);
		cv::equalizeHist(gray, gray);

		//Possible need to play with numbers, further testing required
		window_cascade.detectMultiScale(gray, haarWindows, 1.1, 2, 0 | cv::CASCADE_SCALE_IMAGE, cv::Size(dConst * 2, dConst * 2));
		rect2windowsCC(haarWindows, newWindows);


		for (int i = 0; i < newWindows.size(); i++)
			windowPainter(frame, newWindows[i], cv::Scalar(255, 255, 255));

		cv::resize(frame, frame, cv::Size(preview[0], preview[1]));
		cv::imshow("<LSD> Webcam Feed", frame);

		char c = (char)cv::waitKey(frameTime(int(ms)));
		if (c == 113 || c == 27)
			break;
	}

	cv::destroyAllWindows();

	deleteWindows(newWindows, prevStatic.clone());
	addWindows(newWindows, prevStatic.clone());
	chooseCorners(newWindows, prevStatic.clone());
	cv::destroyAllWindows();
}

void lsd::secondStep(cv::VideoCapture& cap, float time)
{
	assert(cap.isOpened());
	assert(inptQ[0].x != -1);
	assert(outpQ[0].x != -1);
	assert(isTransform);

	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	if(inptQ[0].x == -1)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	if(outpQ[0].x == -1)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	if(!isTransform)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;

	int step = 0;
	float ms = 1000 / cap.get(cv::CAP_PROP_FPS);
	cv::Mat frame;
	cap >> frame;
	cv::Mat pstemp = frame.clone();
	cv::warpPerspective(pstemp, pstemp, transformMat, cv::Size(frame.cols, frame.rows));
	const cv::Mat prevStatic = pstemp.clone();

	if (testBool)
	{
		cv::Mat tmpstat = prevStatic.clone();
		cv::resize(tmpstat, tmpstat, cv::Size(preview[0], preview[1]));
		cv::imshow("<LSD> Perspective transform preview", tmpstat);
		cv::waitKey(0);
	}
	else
	{
		for (;;)
		{
			cap >> frame;
			cv::warpPerspective(frame, frame, transformMat, cv::Size(frame.cols, frame.rows));
			cv::resize(frame, frame, cv::Size(preview[0], preview[1]));
			cv::imshow("<LSD> Perspective transform preview", frame);;
			char c = (char)cv::waitKey(frameTime(int(ms)));
			if (c == 113 || c == 27)
				break;
		}
	}


	cv::destroyAllWindows();

	std::vector <std::vector <cv::Mat> > colouredFrames;
	std::vector <cv::Mat> temp;
	for (int i = 0; i < 3; i++) colouredFrames.push_back(temp);

	frameColorInfo defaultColorInfo = isColorFromFeed(frame, cv::Scalar(-1, -1, -1));
	//LibPiwo communication, request to light up every window in RGB pattern
	//Later to change; use customizable patterns
	std::cout << "<LSD>[Inf] Awaiting signals" << std::endl;
	clock_t begin = clock();

	for (;;)
	{
		int sum = 0;
		for (int i = 0; i < 3; i++)
			sum += colouredFrames[i].size();

		if (sum == calibrationAccuracy * 3)//Everything received
			break;

		if (step == 4)
			break;

		if (!cap.isOpened())
			break;

		cap >> frame;

		if (frame.empty())
			break;

		cv::warpPerspective(frame, frame, transformMat, cv::Size(frame.cols, frame.rows));

		frameColorInfo localColorInfo = isColorFromFeed(frame, defaultColorInfo.colorMat);

		if (localColorInfo.anyColors)
		{
			if (schematic[step] == 0)//Red
			{
				if ((localColorInfo.red) && (!localColorInfo.green) && (!localColorInfo.blue))
				{
					if (colouredFrames[0].size() < calibrationAccuracy)
						colouredFrames[0].push_back(frame.clone());
					else step++;
				}
			}
			if (schematic[step] == 1)//Green
			{
				if ((!localColorInfo.red) && (localColorInfo.green) && (!localColorInfo.blue))
				{
					if (colouredFrames[1].size() < calibrationAccuracy)
						colouredFrames[1].push_back(frame.clone());
					else step++;
				}
			}
			if (schematic[step] == 2)//Blue
			{
				if ((!localColorInfo.red) && (!localColorInfo.green) && (localColorInfo.blue))
				{
					if (colouredFrames[2].size() < calibrationAccuracy)
						colouredFrames[2].push_back(frame.clone());
					else step++;
				}
			}
		}

		if (colouredFrames[0].size() > 0)
		{
			cv::Mat tmpFrame0 = colouredFrames[0][0];
			cv::resize(tmpFrame0, tmpFrame0, cv::Size(preview[0] / 3, preview[1] / 3));
			cv::imshow("<LSD> Colour 0 preview", tmpFrame0);
		}
		if (colouredFrames[1].size() > 0)
		{
			cv::Mat tmpFrame0 = colouredFrames[1][0];
			cv::resize(tmpFrame0, tmpFrame0, cv::Size(preview[0] / 3, preview[1] / 3));
			cv::imshow("<LSD> Colour 1 preview", tmpFrame0);
		}
		if (colouredFrames[2].size() > 0)
		{
			cv::Mat tmpFrame0 = colouredFrames[2][0];
			cv::resize(tmpFrame0, tmpFrame0, cv::Size(preview[0] / 3, preview[1] / 3));
			cv::imshow("<LSD> Colour 2 preview", tmpFrame0);
		}

		cv::Mat scaled = frame.clone();
		cv::resize(scaled, scaled, cv::Size(preview[0], preview[1]));
		cv::imshow("<LSD> Webcam Feed", scaled);

		char c = (char)cv::waitKey(int(ms));
		if (c == 113 || c == 27)
			break;
		clock_t timeStamp = clock();
		if (hasTimeExceeded(begin, timeStamp, time) && !testBool)
		{
			status = TIME_EXCEEDED;
			return;
		}
	}
	cv::destroyAllWindows();
	assert((colouredFrames[0].size() + colouredFrames[1].size() + colouredFrames[2].size()) == (calibrationAccuracy * 3));

	std::vector <cv::Scalar> colLow;
	colLow.push_back(cv::Scalar(0, 0, 16));
	colLow.push_back(cv::Scalar(0, 16, 0));
	colLow.push_back(cv::Scalar(16, 0, 0));
	std::vector <cv::Scalar> colHigh;
	colHigh.push_back(cv::Scalar(5, 5, 255));
	colHigh.push_back(cv::Scalar(16, 255, 16));
	colHigh.push_back(cv::Scalar(255, 16, 16));

	std::vector <windowCC> corneredWindows = calibration(colouredFrames, colLow, colHigh, prevStatic.cols, prevStatic.rows);
	std::vector <windowCC> unartifacted = deleteArtiffacts(corneredWindows);//In case of not finding windows; delete

	cv::Mat windowsWithShapes = prevStatic.clone();

	for (int i = 0; i < unartifacted.size(); i++)
		windowPainter(windowsWithShapes, unartifacted[i], cv::Scalar(255, 255, 255));

	cv::resize(windowsWithShapes, windowsWithShapes, cv::Size(preview[0], preview[1]));
	cv::imshow("<LSD> Windows found", windowsWithShapes);
	cv::waitKey(0);
	cv::destroyAllWindows();

	deleteWindows(unartifacted, prevStatic.clone());
	addWindows(unartifacted, prevStatic.clone());
	arrayTo2DArray(unartifacted);
	cv::destroyAllWindows();

	cv::Mat IDed = prevStatic.clone();

	for (int y = 0; y < twoDim.size(); y++)
	{
		for (int x = 0; x < twoDim[y].size(); x++)
		{
			windowPainter(IDed, twoDim[y][x], cv::Scalar(255, 255, 255));
			std::string xydata = "X:" + std::to_string(x) + " Y:" + std::to_string(y);
			cv::Point tmp = twoDim[y][x].centre;
			tmp.x -= dConst;
			cv::putText(IDed, xydata, tmp, cv::FONT_HERSHEY_SIMPLEX, 0.4, cv::Scalar(255, 255, 16));
		}
	}
	cv::resize(IDed, IDed, cv::Size(preview[0], preview[1]));
	cv::imshow("<LSD> Windows with IDs", IDed);
	cv::waitKey(0);
	cv::destroyAllWindows();
}

void lsd::secondStep(cv::VideoCapture& cap, std::string cascadeName)
{
	assert(cap.isOpened());
	assert(inptQ[0].x != -1);
	assert(outpQ[0].x != -1);
	assert(isTransform);
	assert(cascadeName.size() > 0);

	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	if(inptQ[0].x == -1)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	if(outpQ[0].x == -1)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	if(!isTransform)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	if(cascadeName.size() == 0)
		lsd::status = WRONG_CASCADE_NAME;

	cv::CascadeClassifier window_cascade;
	bool loaded = window_cascade.load(cascadeName);
	assert(loaded);
	if(!loaded)
		lsd::status = CASCADE_NOT_LOADED;

	float ms = 1000 / cap.get(cv::CAP_PROP_FPS);
	cv::Mat frame;
	cap >> frame;
	const cv::Mat prevStatic = frame.clone();

	std::vector<cv::Rect> haarWindows;
	std::vector<windowCC> newWindows;

	std::cout << "<LSD>[Inf] Awaiting signals" << std::endl;

	for (;;)
	{
		if (!cap.isOpened())
			break;

		cap >> frame;

		if (frame.empty())
			break;

		cv::warpPerspective(frame, frame, transformMat, cv::Size(frame.cols, frame.rows));

		cv::Mat gray;
		cv::cvtColor(frame, gray, cv::COLOR_BGR2GRAY);
		cv::equalizeHist(gray, gray);

		//Possible need to play with numbers, further testing required
		window_cascade.detectMultiScale(gray, haarWindows, 1.1, 2, 0 | cv::CASCADE_SCALE_IMAGE, cv::Size(dConst * 2, dConst * 2));
		rect2windowsCC(haarWindows, newWindows);


		for (int i = 0; i < newWindows.size(); i++)
			windowPainter(frame, newWindows[i], cv::Scalar(255, 255, 255));

		cv::resize(frame, frame, cv::Size(preview[0], preview[1]));
		cv::imshow("<LSD> Webcam Feed", frame);

		char c = (char)cv::waitKey(frameTime(int(ms)));
		if (c == 113 || c == 27)
			break;
	}

	cv::destroyAllWindows();

	deleteWindows(newWindows, prevStatic.clone());
	addWindows(newWindows, prevStatic.clone());
	arrayTo2DArray(newWindows);
	cv::destroyAllWindows();

	cv::Mat IDed = prevStatic.clone();

	for (int y = 0; y < twoDim.size(); y++)
	{
		for (int x = 0; x < twoDim[y].size(); x++)
		{
			windowPainter(IDed, twoDim[y][x], cv::Scalar(255, 255, 255));
			std::string xydata = "X:" + std::to_string(x) + " Y:" + std::to_string(y);
			cv::Point tmp = twoDim[y][x].centre;
			tmp.x -= dConst;
			cv::putText(IDed, xydata, tmp, cv::FONT_HERSHEY_SIMPLEX, 0.4, cv::Scalar(255, 255, 16));
		}
	}
	cv::resize(IDed, IDed, cv::Size(preview[0], preview[1]));
	cv::imshow("<LSD> Windows with IDs", IDed);
	cv::waitKey(0);
	cv::destroyAllWindows();
}

finalWin lsd::thirdStep(cv::VideoCapture& cap, float time)
{
	//Time is measured in frames
	assert(time > 0);
	assert(cap.isOpened());
	assert(inptQ[0].x != -1);
	assert(outpQ[0].x != -1);
	assert(isTransform);
	assert(twoDim.size() > 0);
	for (int i = 0; i < twoDim.size(); i++)
		assert(twoDim[i].size() > 0);

	if(time <= 0)
		lsd::status = WRONG_TIME_GIVEN;
	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	if(inptQ[0].x == -1)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	if(outpQ[0].x == -1)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	if(!isTransform)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;
	if(twoDim.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;
	for (int i = 0; i < twoDim.size(); i++)
	{
		if(twoDim[i].size() == 0)
			lsd::status = INCORRECT_ARRAY;
	}

	finalWin output;
	output.accuracy = 0;
	output.coordinate = cv::Point(-1, -1);

	float ms = 1000 / cap.get(cv::CAP_PROP_FPS);
	cv::Mat frame;
	cap >> frame;
	cv::Mat pstemp = frame.clone();
	cv::warpPerspective(pstemp, pstemp, transformMat, cv::Size(frame.cols, frame.rows));
	const cv::Mat prevStatic = pstemp.clone();

	std::vector <std::vector <cv::Mat> > matMatrix;
	std::vector <colorLibrary> windowColorReference;
	matMatrixAssigner(matMatrix, prevStatic.clone(), true);//Create vectors(empty)
	matMatrixAssigner(matMatrix, prevStatic.clone());//Fill vectors

	std::vector <std::vector <frameColorInfo> > baseColors;
	std::vector <std::vector <int> > step;
	std::vector <std::vector <float> > averageWhiteness;

	bool matching = false;

	for (int y = 0; y < matMatrix.size(); y++)
	{
		std::vector <frameColorInfo> FCIodarr;
		std::vector <int> st0;
		std::vector <float> f0;
		for (int x = 0; x < matMatrix[y].size(); x++)
		{
			FCIodarr.push_back(isColorFromFeed(matMatrix[y][x], cv::Scalar(-1, -1, -1)));
			st0.push_back(0);
			f0.push_back(0);

			colorLibrary cl;
			cl.coordinate = cv::Point(x,y);
			windowColorReference.push_back(cl);
		}
		baseColors.push_back(FCIodarr);
		step.push_back(st0);
		averageWhiteness.push_back(f0);
	}

	/*for(int y = 0; y < matMatrix.size(); y++)
	{
		for(int x = 0; x < matMatrix[y].size(); x++)
		{
			std::string name = "X" + std::to_string(x) + ":Y" + std::to_string(y);
			cv::imshow(name,matMatrix[y][x]);
		}
	}
	cv::waitKey(0);*/
	//To avoid loosing sanity, do not un-comment this (unless testing)

	for (;;)//Main loop
	{
		cap >> frame;

		if (frame.empty())
			break;

		if (matching)
			break;

		cv::warpPerspective(frame, frame, transformMat, cv::Size(frame.cols, frame.rows));
		matMatrixAssigner(matMatrix, frame.clone());

		std::vector <std::vector <frameColorInfo> > localColors;

		for (int y = 0; y < matMatrix.size(); y++)
		{
			std::vector <frameColorInfo> FCIodarr;
			for (int x = 0; x < matMatrix[y].size(); x++)
				FCIodarr.push_back(isColorFromFeed(matMatrix[y][x], baseColors[y][x].colorMat));

			localColors.push_back(FCIodarr);
		}

		for (int y = 0; y < twoDim.size(); y++)
		{
			for (int x = 0; x < twoDim[y].size(); x++)
			{
				if (localColors[y][x].anyColors)
				{
					if (step[y][x] == 0)
					{
						if (localColors[y][x].red && !localColors[y][x].green && !localColors[y][x].blue)
						{
							averageWhiteness[y][x] += localColors[y][x].colorMat[2];
							step[y][x]++;
							windowColorReference[y*twoDim[y].size() + x].red = matMatrix[y][x];
						}
					}
					else if (step[y][x] == 1)
					{
						if (!localColors[y][x].red && localColors[y][x].green && !localColors[y][x].blue)
						{
							averageWhiteness[y][x] += localColors[y][x].colorMat[1];
							step[y][x]++;
							windowColorReference[y*twoDim[y].size() + x].green = matMatrix[y][x];
						}
					}
					else if (step[y][x] == 2)
					{
						if (!localColors[y][x].red && !localColors[y][x].green && localColors[y][x].blue)
						{
							averageWhiteness[y][x] += localColors[y][x].colorMat[0];
							step[y][x]++;
							windowColorReference[y*twoDim[y].size() + x].blue = matMatrix[y][x];
						}
					}
				}
			}
		}

		for (int y = 0; y < twoDim.size(); y++)
		{
			for (int x = 0; x < twoDim[y].size(); x++)
			{
				if (step[y][x] == 3)
				{
					//output.coordinate = cv::Point(x, y);
					windowColorReference[y*twoDim[y].size() + x].accuracy = windowColorAccuracy(windowColorReference[y*twoDim[y].size() + x],lsd::colLow,lsd::colHigh);
					windowColorReference[y*twoDim[y].size() + x].coordinate = cv::Point(x, y);
					matching = true;
					//std::cout << "Matching window: " << windowColorReference[y*twoDim[y].size() + x].coordinate  << std::endl;
					//std::cout << "Accuracy: " << windowColorReference[y*twoDim[y].size() + x].accuracy << "%" <<std::endl;
				}
			}
		}

		cv::Mat show = frame.clone();

		for (int y = 0; y < twoDim.size(); y++)
		{
			for (int x = 0; x < twoDim[y].size(); x++)
			{
				if (step[y][x] > 0)
					windowPainter(show, twoDim[y][x], cv::Scalar(255, 255, 255));
			}
		}

		cv::resize(show, show, cv::Size(preview[0], preview[1]));

		cv::imshow("<LSD> Window tracker", show);
		char c = (char)cv::waitKey(frameTime(int(ms)));
		if (c == 113 || c == 27)
			break;
	}
	float maxMatch = 0;
	int id = 0;

	for(int i = 0; i < windowColorReference.size(); i++)
	{
		if(windowColorReference[i].accuracy > maxMatch)
		{
			id = i;
			maxMatch = windowColorReference[i].accuracy;
		}

	}

	output.accuracy = windowColorReference[id].accuracy;
	output.coordinate = windowColorReference[id].coordinate;

	return output;
}

void lsd::matMatrixAssigner(std::vector <std::vector<cv::Mat> >& mats, cv::Mat frame, bool isFirst)//Pass here already transformed image!
{
	assert(!frame.empty());
	if(frame.empty())
		lsd::status = NO_INPUT_DETECTED;

	if (isFirst)
	{
		mats.clear();
		cv::Mat mat0;

		for (int y = 0; y < twoDim.size(); y++)
		{
			std::vector <cv::Mat> matArr;
			for (int x = 0; x < twoDim[y].size(); x++)
				matArr.push_back(mat0);
			mats.push_back(matArr);
		}
		return;
	}
	assert(mats.size() > 0);
	assert(twoDim.size() > 0);
	assert(mats.size() == twoDim.size());

	if(mats.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;
	if(twoDim.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;
	if(mats.size() != twoDim.size())
		lsd::status = SIZES_DOES_NOT_MATCH;

	for (int i = 0; i < twoDim.size(); i++)
		assert(mats[i].size() == twoDim[i].size());

	for (int y = 0; y < twoDim.size(); y++)
	{
		for (int x = 0; x < twoDim[y].size(); x++)
		{
			cv::Rect maskData = windowMask(twoDim[y][x]);
			cv::Mat crop = cv::Mat::zeros(maskData.size(), frame.type());
			cv::Mat mask = cv::Mat::zeros(frame.size(), frame.type());
			cv::Mat cropMask = cv::Mat::zeros(maskData.size(), frame.type());

			cv::Point fillPts[4] = { twoDim[y][x].lUp, twoDim[y][x].rUp, twoDim[y][x].rDown, twoDim[y][x].lDown };
			cv::fillConvexPoly(mask, fillPts, 4, cv::Scalar(255, 255, 255));
			crop = frame(maskData).clone();
			cropMask = mask(maskData).clone();

			cv::bitwise_and(crop, cropMask, crop);
			mats[y][x] = crop.clone();
		}
	}


}

cv::Rect lsd::windowMask(windowCC& window)
{
	int minmx = 50000;//If we want to use display wider than 50k pixels, this might not work
	int maxmx = 0;
	int minmy = 50000;//If we want to use display higher than 50k pixels, this might not work
	int maxmy = 0;

	if (window.lUp.x < minmx)
		minmx = window.lUp.x;
	if (window.lUp.x > maxmx)
		maxmx = window.lUp.x;

	if (window.lUp.y < minmy)
		minmy = window.lUp.y;
	if (window.lUp.y > maxmy)
		maxmy = window.lUp.y;



	if (window.rUp.x < minmx)
		minmx = window.rUp.x;
	if (window.rUp.x > maxmx)
		maxmx = window.rUp.x;

	if (window.rUp.y < minmy)
		minmy = window.rUp.y;
	if (window.rUp.y > maxmy)
		maxmy = window.rUp.y;



	if (window.rDown.x < minmx)
		minmx = window.rDown.x;
	if (window.rDown.x > maxmx)
		maxmx = window.rDown.x;

	if (window.rDown.y < minmy)
		minmy = window.rDown.y;
	if (window.rDown.y > maxmy)
		maxmy = window.rDown.y;



	if (window.lDown.x < minmx)
		minmx = window.lDown.x;
	if (window.lDown.x > maxmx)
		maxmx = window.lDown.x;

	if (window.lDown.y < minmy)
		minmy = window.lDown.y;
	if (window.lDown.y > maxmy)
		maxmy = window.lDown.y;

	return cv::Rect(cv::Point(minmx, minmy), cv::Point(maxmx, maxmy));
}

std::vector<coorColor> lsd::whatAreWindowColors(cv::VideoCapture& cap, float thresh)
{
	assert(cap.isOpened());
	assert(twoDim.size() > 0);
	for (int i = 0; i < twoDim.size(); i++)
		assert(twoDim[i].size() > 0);
	assert(isTransform);

	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	if(twoDim.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;
	for (int i = 0; i < twoDim.size(); i++)
	{
		if(twoDim[i].size() == 0)
			lsd::status = INCORRECT_ARRAY;
	}
	if(!isTransform)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;

	cv::Mat frame;
	cap >> frame;

	cv::Mat pstemp = frame.clone();
	cv::warpPerspective(pstemp, pstemp, transformMat, cv::Size(frame.cols, frame.rows));
	const cv::Mat prevStatic = pstemp.clone();

	std::vector <std::vector <cv::Mat> > matMatrix;
	matMatrixAssigner(matMatrix, prevStatic.clone(), true);//Create vectors(empty)
	matMatrixAssigner(matMatrix, prevStatic.clone());//Fill vectors

	std::vector <coorColor> output;

	for (int y = 0; y < windowsY; y++)
	{
		for (int x = 0; x < windowsX; x++)
		{
			if (matAverageValue(matMatrix[y][x]) >= thresh)
			{
				cv::Scalar mean = cv::mean(matMatrix[y][x]);
				coorColor out;
				out.coor = cv::Point(x, y);
				out.color = mean;
				output.push_back(out);
			}

		}
	}

	return output;
}

cv::Scalar lsd::whatIsMyColor(int x, int y, cv::VideoCapture& cap, float thresh)
{
	assert(cap.isOpened());
	assert(twoDim.size() > 0);
	for (int i = 0; i < twoDim.size(); i++)
		assert(twoDim[i].size() > 0);
	assert(x > 0 && x <= windowsX);
	assert(y > 0 && y <= windowsY);
	assert(isTransform);

	if(!cap.isOpened())
		lsd::status = NO_INPUT_DETECTED;
	if(twoDim.size() == 0)
		lsd::status = EMPTY_INPUT_GIVEN;
	for (int i = 0; i < twoDim.size(); i++)
	{
		if(twoDim[i].size() == 0)
			lsd::status = INCORRECT_ARRAY;
	}
	if(!(x > 0 && x <= windowsX))
		lsd::status = WRONG_GIVEN_COORDINATE_X;
	if(!(y > 0 && x <= windowsY))
		lsd::status = WRONG_GIVEN_COORDINATE_Y;
	if(!isTransform)
		lsd::status = TRANSFORM_ARRAY_INAPROPRIATE_OR_ABSENT;

	cv::Mat frame;
	cap >> frame;

	cv::Mat pstemp = frame.clone();
	cv::warpPerspective(pstemp, pstemp, transformMat, cv::Size(frame.cols, frame.rows));
	const cv::Mat prevStatic = pstemp.clone();

	std::vector <std::vector <cv::Mat> > matMatrix;
	matMatrixAssigner(matMatrix, prevStatic.clone(), true);//Create vectors(empty)
	matMatrixAssigner(matMatrix, prevStatic.clone());//Fill vectors

	cv::Scalar output;

	if (matAverageValue(matMatrix[y][x]) >= thresh)
	{
		output = cv::mean(matMatrix[y][x]);

	}
	else
	{
		output = cv::Scalar(-1, -1, -1, -1);
	}

	return output;
}

//You have made to the very end! Have a small easter egg and this cookie
//		(\_/)
//		( `_`)
//		(> )>o
//		U U